<?php

define( 'MAGPIE_CACHE_ON', 1 ); //2.7 Cache Bug
define( 'MAGPIE_CACHE_AGE', 900 );
define( 'MAGPIE_INPUT_ENCODING', 'UTF-8' );
define( 'MAGPIE_OUTPUT_ENCODING', 'UTF-8' );

function su_get_tweets($username, $limit, $consumerkey, $consumersecret, $accesstoken, $accesstokensecret) {
	
	$consumer_key = $consumerkey;
	$consumer_key_secret = $consumersecret;
	$consumer_token = $accesstoken;
	$consumer_token_secret = $accesstokensecret;
	$twitter_output = '';
	
	// new API 1.1
	if ( !class_exists('TwitterOAuth')) {
		require_once ('twitteroauth.php');
	}
	$connection = new TwitterOAuth($consumer_key, $consumer_key_secret, $consumer_token, $consumer_token_secret);

	$twitter_output .= '<div id="twitter_div"><ul id="twitter_update_list">';
	
	$twitter_json_url = 'https://api.twitter.com/1.1/statuses/user_timeline.json?screen_name='.$username.'&amp;include_rts=true&amp;count='.$limit;
	$api_1_1_content = $connection->get($twitter_json_url);
	
	if ( is_array( $api_1_1_content ) AND isset( $api_1_1_content[0] -> id ) ) {
		$tweets = $api_1_1_content;
		$author = $tweets[0] -> user -> screen_name;
	} else {
		$tweets = array();
	}
	
	function time_since( $original, $do_more = 0 ) {
	// array of time period chunks
	$chunks = array(
		array(60 * 60 * 24 * 365 , 'year'),
		array(60 * 60 * 24 * 30 , 'month'),
		array(60 * 60 * 24 * 7, 'week'),
		array(60 * 60 * 24 , 'day'),
		array(60 * 60 , 'hour'),
		array(60 , 'minute'),
	);

	$today = time();
	$since = $today - $original;

	for ($i = 0, $j = count($chunks); $i < $j; $i++) {
		$seconds = $chunks[$i][0];
		$name = $chunks[$i][1];
		if (($count = floor($since / $seconds)) != 0)
			break;
	}
	
	if ( !function_exists('jltw_format_tweettext')) {
		function jltw_format_tweettext($raw_tweet, $username) {
			$target4a = '_blank';
			$i_text = $raw_tweet;			
			//$i_text = htmlspecialchars_decode($raw_tweet);
			//$i_text = preg_replace('#(([a-zA-Z0-9_-]{1,130})\.([a-z]{2,4})(/[a-zA-Z0-9_-]+)?((\#)([a-zA-Z0-9_-]+))?)#','<a href="//$1">$1</a>',$i_text); 
			// replace tag
			$i_text = preg_replace('#\<([a-zA-Z])\>#','&lt;$1&gt;',$i_text);
			// replace ending tag
			$i_text = preg_replace('#\<\/([a-zA-Z])\>#','&lt;/$1&gt;',$i_text);
			// replace classic url
			$i_text = preg_replace('#(((https?|ftp)://(w{3}\.)?)(?<!www)(\w+-?)*\.([a-z]{2,4})(/[a-zA-Z0-9_\?\=-]+)?)#',' <a href="$1" rel="nofollow" class="juiz_last_tweet_url" target="'.$target4a.'">$5.$6$7</a>',$i_text);
			// replace user link
			$i_text = preg_replace('#@([a-zA-z0-9_]+)#i','<a href="http://twitter.com/$1" class="juiz_last_tweet_tweetos" rel="nofollow" target="'.$target4a.'">@$1</a>',$i_text);
			// replace hash tag search link ([a-zA-z0-9_] recently replaced by \S)
			$i_text = preg_replace('#[^&]\#(\S+)#i',' <a href="http://twitter.com/search/?src=hash&amp;q=%23$1" class="juiz_last_tweet_hastag" rel="nofollow" target="'.$target4a.'">#$1</a>',$i_text); // old url was : /search/%23$1
			// remove start username
			$i_text = preg_replace( '#^'.$username.': #i', '', $i_text );
			return $i_text;
		}
	}

	$print = ($count == 1) ? '1 '.$name : "$count {$name}s";

	if ($i + 1 < $j) {
		$seconds2 = $chunks[$i + 1][0];
		$name2 = $chunks[$i + 1][1];
		// add second item if it's greater than 0
		if ( (($count2 = floor(($since - ($seconds * $count)) / $seconds2)) != 0) && $do_more )
			$print .= ($count2 == 1) ? ', 1 '.$name2 : ", $count2 {$name2}s";
		}
		return $print;
	}


	$tw_counter = 0;
	foreach( (array) $tweets as $tweet ) {
		if ( $tw_counter <= $limit ) {
			if ( empty( $tweet -> text ) )
			continue;
		$tweet_createdat = $tweet -> created_at;
		$tweet_link	= "http://twitter.com/".$tweet -> user -> screen_name."/status/".$tweet -> id_str;
		$tweet_text = $tweet -> text;
		$tweet_text = esc_html( $tweet_text ); // escape here so that Twitter handles in Tweets don't get mangled
		$tweet_text = make_clickable( $tweet_text ); 
		$twitter_output .= 
		'<li>'.
			$tweet_text
			.'<a href="'.esc_url($tweet_link).'" class="timesince" target="_blank">'.esc_html( str_replace( ' ', '&nbsp;', time_since( strtotime( $tweet_createdat ) ) ) ).'&nbsp;ago</a>
		</li>';
		$tw_counter = $tw_counter + 1;
		}
	}
	
	
	$twitter_output .= '</ul></div>';
	return $twitter_output;
	
}

?>